#pragma once

namespace Simulator {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Collections::Generic;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::Globalization;

       public value class FileAndLine 
	{
	public:
		String^ filename;
		int lineNumber;
		String^ sourceLabel;
	};

	ref class MachineState;
	ref class Disassembly;
	ref class MicroDisassembly;	

	/// <summary>
	/// Summary for MainForm
	///
	/// WARNING: If you change the name of this class, you will need to change the
	///          'Resource File Name' property for the managed resource compiler tool
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public ref class MainForm : public System::Windows::Forms::Form
	{
	

	public:
		MainForm(void)
		{
			InitializeComponent();	

			m_ignoreSource = false;
		}
	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~MainForm()
		{
			if (components)
			{
				delete components;
			}
		}


	protected: 

	protected: 

	private: System::Windows::Forms::TextBox^  m_lcdTextBox;
	private: System::Windows::Forms::Label^  m_pcLabel;





	private: System::Windows::Forms::Label^  m_aLabel;



	private: System::Windows::Forms::Label^  label1;
       private: System::Windows::Forms::Label^  m_fetchLabel;





	private: System::Windows::Forms::Label^  label6;
	private: System::Windows::Forms::Label^  label7;


	private: System::Windows::Forms::Label^  label10;
	private: System::Windows::Forms::TextBox^  m_memoryViewTextBox;

	private: System::Windows::Forms::Label^  label11;
	private: System::Windows::Forms::RadioButton^  m_cRadioButton;
	private: System::Windows::Forms::RadioButton^  m_eRadioButton;









	private: System::Windows::Forms::Button^  m_continueButtton;
	private: System::Windows::Forms::Button^  m_pauseButton;
	private: System::Windows::Forms::Button^  m_resetButton;




	private: System::Windows::Forms::Button^  m_stepButton;
	private: System::Windows::Forms::Button^  m_microStepButton;
	private: System::Windows::Forms::Label^  label13;
	private: System::Windows::Forms::Label^  m_phaseLabel;
	private: System::Windows::Forms::Panel^  panel1;

	private: System::Windows::Forms::Label^  m_microDisassemblyViewTitle;



	private: System::Windows::Forms::Label^  m_opLabel;
	private: System::Windows::Forms::Label^  label14;


	private: System::Windows::Forms::ToolTip^  m_tooltip;
	private: System::Windows::Forms::ListView^  m_sourceListView;
	private: System::Windows::Forms::ImageList^  m_debuggerImageList;
	private: System::Windows::Forms::ColumnHeader^  columnHeader1;
	private: System::Windows::Forms::ListView^  m_microSourceListView;
	private: System::Windows::Forms::ColumnHeader^  columnHeader2;
	private: System::Windows::Forms::Button^  m_clearBreakpointsButton;
	private: System::Windows::Forms::MenuStrip^  menuStrip1;
	private: System::Windows::Forms::ToolStripMenuItem^  fileToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  openProgramROMToolStripMenuItem;

	private: System::Windows::Forms::ToolStripSeparator^  toolStripMenuItem1;
	private: System::Windows::Forms::ToolStripMenuItem^  exitToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  toolStripMenuItem2;
	private: System::Windows::Forms::CheckBox^  m_ShowDisassemblyCheckbox;






private: System::Windows::Forms::ToolStripMenuItem^  toolStripMenuItem3;
private: System::Windows::Forms::ToolStripMenuItem^  toolStripMenuItem4;
private: System::Windows::Forms::ToolStripMenuItem^  toolStripMenuItem5;
private: System::Windows::Forms::ToolStripMenuItem^  toolStripMenuItem6;


private: System::Windows::Forms::Button^  m_buttonLeft;
private: System::Windows::Forms::Button^  m_buttonRight;
private: System::Windows::Forms::Button^  m_buttonUp;
private: System::Windows::Forms::Button^  m_buttonDown;
private: System::Windows::Forms::Label^  m_out1Label;
private: System::Windows::Forms::Label^  m_out0Label;
private: System::Windows::Forms::Label^  label5;
private: System::Windows::Forms::Label^  label4;
private: System::Windows::Forms::Label^  m_Xlabel;
private: System::Windows::Forms::Label^  label3;
private: System::Windows::Forms::Label^  label2;
private: System::Windows::Forms::Label^  m_statusLabel;
private: System::Windows::Forms::Label^  m_timeLabel;
private: System::Windows::Forms::Button^  m_resetTimeButton;

	private: System::ComponentModel::IContainer^  components;







	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>


#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
                  this->components = (gcnew System::ComponentModel::Container());
                  System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(MainForm::typeid));
                  this->m_lcdTextBox = (gcnew System::Windows::Forms::TextBox());
                  this->m_pcLabel = (gcnew System::Windows::Forms::Label());
                  this->m_aLabel = (gcnew System::Windows::Forms::Label());
                  this->label1 = (gcnew System::Windows::Forms::Label());
                  this->m_fetchLabel = (gcnew System::Windows::Forms::Label());
                  this->label6 = (gcnew System::Windows::Forms::Label());
                  this->label7 = (gcnew System::Windows::Forms::Label());
                  this->label10 = (gcnew System::Windows::Forms::Label());
                  this->m_memoryViewTextBox = (gcnew System::Windows::Forms::TextBox());
                  this->label11 = (gcnew System::Windows::Forms::Label());
                  this->m_cRadioButton = (gcnew System::Windows::Forms::RadioButton());
                  this->m_eRadioButton = (gcnew System::Windows::Forms::RadioButton());
                  this->m_continueButtton = (gcnew System::Windows::Forms::Button());
                  this->m_pauseButton = (gcnew System::Windows::Forms::Button());
                  this->m_resetButton = (gcnew System::Windows::Forms::Button());
                  this->m_stepButton = (gcnew System::Windows::Forms::Button());
                  this->m_microStepButton = (gcnew System::Windows::Forms::Button());
                  this->label13 = (gcnew System::Windows::Forms::Label());
                  this->m_phaseLabel = (gcnew System::Windows::Forms::Label());
                  this->panel1 = (gcnew System::Windows::Forms::Panel());
                  this->m_out1Label = (gcnew System::Windows::Forms::Label());
                  this->m_out0Label = (gcnew System::Windows::Forms::Label());
                  this->label5 = (gcnew System::Windows::Forms::Label());
                  this->label4 = (gcnew System::Windows::Forms::Label());
                  this->m_Xlabel = (gcnew System::Windows::Forms::Label());
                  this->label3 = (gcnew System::Windows::Forms::Label());
                  this->label2 = (gcnew System::Windows::Forms::Label());
                  this->m_opLabel = (gcnew System::Windows::Forms::Label());
                  this->m_microDisassemblyViewTitle = (gcnew System::Windows::Forms::Label());
                  this->label14 = (gcnew System::Windows::Forms::Label());
                  this->m_tooltip = (gcnew System::Windows::Forms::ToolTip(this->components));
                  this->m_sourceListView = (gcnew System::Windows::Forms::ListView());
                  this->columnHeader1 = (gcnew System::Windows::Forms::ColumnHeader());
                  this->m_debuggerImageList = (gcnew System::Windows::Forms::ImageList(this->components));
                  this->m_microSourceListView = (gcnew System::Windows::Forms::ListView());
                  this->columnHeader2 = (gcnew System::Windows::Forms::ColumnHeader());
                  this->m_clearBreakpointsButton = (gcnew System::Windows::Forms::Button());
                  this->menuStrip1 = (gcnew System::Windows::Forms::MenuStrip());
                  this->fileToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
                  this->openProgramROMToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
                  this->toolStripMenuItem2 = (gcnew System::Windows::Forms::ToolStripMenuItem());
                  this->toolStripMenuItem3 = (gcnew System::Windows::Forms::ToolStripMenuItem());
                  this->toolStripMenuItem4 = (gcnew System::Windows::Forms::ToolStripMenuItem());
                  this->toolStripMenuItem5 = (gcnew System::Windows::Forms::ToolStripMenuItem());
                  this->toolStripMenuItem6 = (gcnew System::Windows::Forms::ToolStripMenuItem());
                  this->toolStripMenuItem1 = (gcnew System::Windows::Forms::ToolStripSeparator());
                  this->exitToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
                  this->m_ShowDisassemblyCheckbox = (gcnew System::Windows::Forms::CheckBox());
                  this->m_buttonLeft = (gcnew System::Windows::Forms::Button());
                  this->m_buttonRight = (gcnew System::Windows::Forms::Button());
                  this->m_buttonUp = (gcnew System::Windows::Forms::Button());
                  this->m_buttonDown = (gcnew System::Windows::Forms::Button());
                  this->m_statusLabel = (gcnew System::Windows::Forms::Label());
                  this->m_timeLabel = (gcnew System::Windows::Forms::Label());
                  this->m_resetTimeButton = (gcnew System::Windows::Forms::Button());
                  this->panel1->SuspendLayout();
                  this->menuStrip1->SuspendLayout();
                  this->SuspendLayout();
                  // 
                  // m_lcdTextBox
                  // 
                  this->m_lcdTextBox->BackColor = System::Drawing::SystemColors::Window;
                  this->m_lcdTextBox->Font = (gcnew System::Drawing::Font(L"Courier New", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
                      static_cast<System::Byte>(0)));
                  this->m_lcdTextBox->Location = System::Drawing::Point(9, 272);
                  this->m_lcdTextBox->Multiline = true;
                  this->m_lcdTextBox->Name = L"m_lcdTextBox";
                  this->m_lcdTextBox->ReadOnly = true;
                  this->m_lcdTextBox->Size = System::Drawing::Size(142, 39);
                  this->m_lcdTextBox->TabIndex = 2;
                  this->m_lcdTextBox->Text = L"0123456789ABCDEF";
                  this->m_lcdTextBox->WordWrap = false;
                  // 
                  // m_pcLabel
                  // 
                  this->m_pcLabel->AutoSize = true;
                  this->m_pcLabel->BackColor = System::Drawing::SystemColors::Window;
                  this->m_pcLabel->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
                  this->m_pcLabel->Font = (gcnew System::Drawing::Font(L"Courier New", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
                      static_cast<System::Byte>(0)));
                  this->m_pcLabel->Location = System::Drawing::Point(116, 8);
                  this->m_pcLabel->Name = L"m_pcLabel";
                  this->m_pcLabel->Size = System::Drawing::Size(34, 18);
                  this->m_pcLabel->TabIndex = 3;
                  this->m_pcLabel->Text = L"ABC";
                  // 
                  // m_aLabel
                  // 
                  this->m_aLabel->AutoSize = true;
                  this->m_aLabel->BackColor = System::Drawing::SystemColors::Window;
                  this->m_aLabel->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
                  this->m_aLabel->Font = (gcnew System::Drawing::Font(L"Courier New", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
                      static_cast<System::Byte>(0)));
                  this->m_aLabel->Location = System::Drawing::Point(19, 8);
                  this->m_aLabel->Name = L"m_aLabel";
                  this->m_aLabel->Size = System::Drawing::Size(18, 18);
                  this->m_aLabel->TabIndex = 6;
                  this->m_aLabel->Text = L"A";
                  // 
                  // label1
                  // 
                  this->label1->AutoSize = true;
                  this->label1->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
                      static_cast<System::Byte>(0)));
                  this->label1->Location = System::Drawing::Point(3, 10);
                  this->label1->Name = L"label1";
                  this->label1->Size = System::Drawing::Size(14, 13);
                  this->label1->TabIndex = 10;
                  this->label1->Text = L"A";
                  // 
                  // m_fetchLabel
                  // 
                  this->m_fetchLabel->AutoSize = true;
                  this->m_fetchLabel->BackColor = System::Drawing::SystemColors::Window;
                  this->m_fetchLabel->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
                  this->m_fetchLabel->Font = (gcnew System::Drawing::Font(L"Courier New", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
                      static_cast<System::Byte>(0)));
                  this->m_fetchLabel->Location = System::Drawing::Point(39, 37);
                  this->m_fetchLabel->Name = L"m_fetchLabel";
                  this->m_fetchLabel->Size = System::Drawing::Size(26, 18);
                  this->m_fetchLabel->TabIndex = 14;
                  this->m_fetchLabel->Text = L"AB";
                  // 
                  // label6
                  // 
                  this->label6->AutoSize = true;
                  this->label6->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
                      static_cast<System::Byte>(0)));
                  this->label6->Location = System::Drawing::Point(202, 39);
                  this->label6->Name = L"label6";
                  this->label6->Size = System::Drawing::Size(56, 13);
                  this->label6->TabIndex = 15;
                  this->label6->Text = L"Instruction";
                  // 
                  // label7
                  // 
                  this->label7->AutoSize = true;
                  this->label7->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
                      static_cast<System::Byte>(0)));
                  this->label7->Location = System::Drawing::Point(93, 10);
                  this->label7->Name = L"label7";
                  this->label7->Size = System::Drawing::Size(21, 13);
                  this->label7->TabIndex = 16;
                  this->label7->Text = L"PC";
                  // 
                  // label10
                  // 
                  this->label10->AutoSize = true;
                  this->label10->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
                      static_cast<System::Byte>(0)));
                  this->label10->Location = System::Drawing::Point(9, 256);
                  this->label10->Name = L"label10";
                  this->label10->Size = System::Drawing::Size(28, 13);
                  this->label10->TabIndex = 19;
                  this->label10->Text = L"LCD";
                  // 
                  // m_memoryViewTextBox
                  // 
                  this->m_memoryViewTextBox->BackColor = System::Drawing::SystemColors::Window;
                  this->m_memoryViewTextBox->Font = (gcnew System::Drawing::Font(L"Courier New", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
                      static_cast<System::Byte>(0)));
                  this->m_memoryViewTextBox->Location = System::Drawing::Point(10, 145);
                  this->m_memoryViewTextBox->Multiline = true;
                  this->m_memoryViewTextBox->Name = L"m_memoryViewTextBox";
                  this->m_memoryViewTextBox->ReadOnly = true;
                  this->m_memoryViewTextBox->ScrollBars = System::Windows::Forms::ScrollBars::Vertical;
                  this->m_memoryViewTextBox->Size = System::Drawing::Size(306, 98);
                  this->m_memoryViewTextBox->TabIndex = 20;
                  this->m_memoryViewTextBox->Text = L"NNN 0 1 2 3 4 5 6 7 8 9 A B C D E F";
                  this->m_memoryViewTextBox->WordWrap = false;
                  // 
                  // label11
                  // 
                  this->label11->AutoSize = true;
                  this->label11->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
                      static_cast<System::Byte>(0)));
                  this->label11->Location = System::Drawing::Point(9, 129);
                  this->label11->Name = L"label11";
                  this->label11->Size = System::Drawing::Size(70, 13);
                  this->label11->TabIndex = 21;
                  this->label11->Text = L"Memory View";
                  // 
                  // m_cRadioButton
                  // 
                  this->m_cRadioButton->AutoCheck = false;
                  this->m_cRadioButton->AutoSize = true;
                  this->m_cRadioButton->Location = System::Drawing::Point(232, 9);
                  this->m_cRadioButton->Name = L"m_cRadioButton";
                  this->m_cRadioButton->Size = System::Drawing::Size(32, 17);
                  this->m_cRadioButton->TabIndex = 22;
                  this->m_cRadioButton->TabStop = true;
                  this->m_cRadioButton->Text = L"C";
                  this->m_cRadioButton->UseVisualStyleBackColor = true;
                  // 
                  // m_eRadioButton
                  // 
                  this->m_eRadioButton->AutoCheck = false;
                  this->m_eRadioButton->AutoSize = true;
                  this->m_eRadioButton->Location = System::Drawing::Point(268, 9);
                  this->m_eRadioButton->Name = L"m_eRadioButton";
                  this->m_eRadioButton->Size = System::Drawing::Size(32, 17);
                  this->m_eRadioButton->TabIndex = 24;
                  this->m_eRadioButton->TabStop = true;
                  this->m_eRadioButton->Text = L"Z";
                  this->m_eRadioButton->UseVisualStyleBackColor = true;
                  // 
                  // m_continueButtton
                  // 
                  this->m_continueButtton->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Left));
                  this->m_continueButtton->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"m_continueButtton.Image")));
                  this->m_continueButtton->Location = System::Drawing::Point(10, 428);
                  this->m_continueButtton->Name = L"m_continueButtton";
                  this->m_continueButtton->Size = System::Drawing::Size(32, 23);
                  this->m_continueButtton->TabIndex = 32;
                  this->m_continueButtton->UseVisualStyleBackColor = true;
                  this->m_continueButtton->Click += gcnew System::EventHandler(this, &MainForm::m_continueButtton_Click);
                  // 
                  // m_pauseButton
                  // 
                  this->m_pauseButton->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Left));
                  this->m_pauseButton->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"m_pauseButton.Image")));
                  this->m_pauseButton->Location = System::Drawing::Point(60, 428);
                  this->m_pauseButton->Name = L"m_pauseButton";
                  this->m_pauseButton->Size = System::Drawing::Size(32, 23);
                  this->m_pauseButton->TabIndex = 33;
                  this->m_pauseButton->UseVisualStyleBackColor = true;
                  this->m_pauseButton->Click += gcnew System::EventHandler(this, &MainForm::m_pauseButton_Click);
                  // 
                  // m_resetButton
                  // 
                  this->m_resetButton->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Left));
                  this->m_resetButton->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"m_resetButton.Image")));
                  this->m_resetButton->Location = System::Drawing::Point(210, 428);
                  this->m_resetButton->Name = L"m_resetButton";
                  this->m_resetButton->Size = System::Drawing::Size(32, 23);
                  this->m_resetButton->TabIndex = 34;
                  this->m_resetButton->UseVisualStyleBackColor = true;
                  this->m_resetButton->Click += gcnew System::EventHandler(this, &MainForm::m_resetButton_Click);
                  // 
                  // m_stepButton
                  // 
                  this->m_stepButton->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Left));
                  this->m_stepButton->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"m_stepButton.Image")));
                  this->m_stepButton->Location = System::Drawing::Point(160, 428);
                  this->m_stepButton->Name = L"m_stepButton";
                  this->m_stepButton->Size = System::Drawing::Size(32, 23);
                  this->m_stepButton->TabIndex = 37;
                  this->m_stepButton->UseVisualStyleBackColor = true;
                  this->m_stepButton->Click += gcnew System::EventHandler(this, &MainForm::m_stepButton_Click);
                  // 
                  // m_microStepButton
                  // 
                  this->m_microStepButton->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Left));
                  this->m_microStepButton->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"m_microStepButton.Image")));
                  this->m_microStepButton->Location = System::Drawing::Point(110, 428);
                  this->m_microStepButton->Name = L"m_microStepButton";
                  this->m_microStepButton->Size = System::Drawing::Size(32, 23);
                  this->m_microStepButton->TabIndex = 38;
                  this->m_microStepButton->UseVisualStyleBackColor = true;
                  this->m_microStepButton->Click += gcnew System::EventHandler(this, &MainForm::m_microStepButton_Click);
                  // 
                  // label13
                  // 
                  this->label13->AutoSize = true;
                  this->label13->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
                      static_cast<System::Byte>(0)));
                  this->label13->Location = System::Drawing::Point(160, 10);
                  this->label13->Name = L"label13";
                  this->label13->Size = System::Drawing::Size(37, 13);
                  this->label13->TabIndex = 40;
                  this->label13->Text = L"Phase";
                  // 
                  // m_phaseLabel
                  // 
                  this->m_phaseLabel->AutoSize = true;
                  this->m_phaseLabel->BackColor = System::Drawing::SystemColors::Window;
                  this->m_phaseLabel->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
                  this->m_phaseLabel->Font = (gcnew System::Drawing::Font(L"Courier New", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
                      static_cast<System::Byte>(0)));
                  this->m_phaseLabel->Location = System::Drawing::Point(199, 8);
                  this->m_phaseLabel->Name = L"m_phaseLabel";
                  this->m_phaseLabel->Size = System::Drawing::Size(18, 18);
                  this->m_phaseLabel->TabIndex = 39;
                  this->m_phaseLabel->Text = L"A";
                  // 
                  // panel1
                  // 
                  this->panel1->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
                  this->panel1->Controls->Add(this->m_out1Label);
                  this->panel1->Controls->Add(this->m_out0Label);
                  this->panel1->Controls->Add(this->label5);
                  this->panel1->Controls->Add(this->label4);
                  this->panel1->Controls->Add(this->m_Xlabel);
                  this->panel1->Controls->Add(this->label3);
                  this->panel1->Controls->Add(this->label2);
                  this->panel1->Controls->Add(this->m_opLabel);
                  this->panel1->Controls->Add(this->label13);
                  this->panel1->Controls->Add(this->m_phaseLabel);
                  this->panel1->Controls->Add(this->m_aLabel);
                  this->panel1->Controls->Add(this->m_eRadioButton);
                  this->panel1->Controls->Add(this->label7);
                  this->panel1->Controls->Add(this->m_cRadioButton);
                  this->panel1->Controls->Add(this->m_pcLabel);
                  this->panel1->Controls->Add(this->label1);
                  this->panel1->Controls->Add(this->label6);
                  this->panel1->Controls->Add(this->m_fetchLabel);
                  this->panel1->Location = System::Drawing::Point(12, 37);
                  this->panel1->Name = L"panel1";
                  this->panel1->Size = System::Drawing::Size(307, 76);
                  this->panel1->TabIndex = 41;
                  // 
                  // m_out1Label
                  // 
                  this->m_out1Label->AutoSize = true;
                  this->m_out1Label->BackColor = System::Drawing::SystemColors::Window;
                  this->m_out1Label->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
                  this->m_out1Label->Font = (gcnew System::Drawing::Font(L"Courier New", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
                      static_cast<System::Byte>(0)));
                  this->m_out1Label->Location = System::Drawing::Point(170, 37);
                  this->m_out1Label->Name = L"m_out1Label";
                  this->m_out1Label->Size = System::Drawing::Size(18, 18);
                  this->m_out1Label->TabIndex = 49;
                  this->m_out1Label->Text = L"A";
                  // 
                  // m_out0Label
                  // 
                  this->m_out0Label->AutoSize = true;
                  this->m_out0Label->BackColor = System::Drawing::SystemColors::Window;
                  this->m_out0Label->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
                  this->m_out0Label->Font = (gcnew System::Drawing::Font(L"Courier New", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
                      static_cast<System::Byte>(0)));
                  this->m_out0Label->Location = System::Drawing::Point(108, 37);
                  this->m_out0Label->Name = L"m_out0Label";
                  this->m_out0Label->Size = System::Drawing::Size(18, 18);
                  this->m_out0Label->TabIndex = 48;
                  this->m_out0Label->Text = L"A";
                  // 
                  // label5
                  // 
                  this->label5->AutoSize = true;
                  this->label5->Location = System::Drawing::Point(138, 39);
                  this->label5->Name = L"label5";
                  this->label5->Size = System::Drawing::Size(30, 13);
                  this->label5->TabIndex = 47;
                  this->label5->Text = L"Out1";
                  // 
                  // label4
                  // 
                  this->label4->AutoSize = true;
                  this->label4->Location = System::Drawing::Point(76, 39);
                  this->label4->Name = L"label4";
                  this->label4->Size = System::Drawing::Size(30, 13);
                  this->label4->TabIndex = 46;
                  this->label4->Text = L"Out0";
                  // 
                  // m_Xlabel
                  // 
                  this->m_Xlabel->AutoSize = true;
                  this->m_Xlabel->BackColor = System::Drawing::SystemColors::Window;
                  this->m_Xlabel->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
                  this->m_Xlabel->Font = (gcnew System::Drawing::Font(L"Courier New", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
                      static_cast<System::Byte>(0)));
                  this->m_Xlabel->Location = System::Drawing::Point(65, 8);
                  this->m_Xlabel->Name = L"m_Xlabel";
                  this->m_Xlabel->Size = System::Drawing::Size(18, 18);
                  this->m_Xlabel->TabIndex = 45;
                  this->m_Xlabel->Text = L"*";
                  // 
                  // label3
                  // 
                  this->label3->AutoSize = true;
                  this->label3->Location = System::Drawing::Point(49, 10);
                  this->label3->Name = L"label3";
                  this->label3->Size = System::Drawing::Size(14, 13);
                  this->label3->TabIndex = 44;
                  this->label3->Text = L"X";
                  // 
                  // label2
                  // 
                  this->label2->AutoSize = true;
                  this->label2->Location = System::Drawing::Point(3, 39);
                  this->label2->Name = L"label2";
                  this->label2->Size = System::Drawing::Size(34, 13);
                  this->label2->TabIndex = 43;
                  this->label2->Text = L"Fetch";
                  // 
                  // m_opLabel
                  // 
                  this->m_opLabel->AutoSize = true;
                  this->m_opLabel->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
                      static_cast<System::Byte>(0)));
                  this->m_opLabel->Location = System::Drawing::Point(259, 39);
                  this->m_opLabel->Name = L"m_opLabel";
                  this->m_opLabel->Size = System::Drawing::Size(33, 13);
                  this->m_opLabel->TabIndex = 42;
                  this->m_opLabel->Text = L"NOP";
                  // 
                  // m_microDisassemblyViewTitle
                  // 
                  this->m_microDisassemblyViewTitle->AutoSize = true;
                  this->m_microDisassemblyViewTitle->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Regular, 
                      System::Drawing::GraphicsUnit::Point, static_cast<System::Byte>(0)));
                  this->m_microDisassemblyViewTitle->Location = System::Drawing::Point(7, 322);
                  this->m_microDisassemblyViewTitle->Name = L"m_microDisassemblyViewTitle";
                  this->m_microDisassemblyViewTitle->Size = System::Drawing::Size(120, 13);
                  this->m_microDisassemblyViewTitle->TabIndex = 43;
                  this->m_microDisassemblyViewTitle->Text = L"Micro-Disassembly View";
                  // 
                  // label14
                  // 
                  this->label14->AutoSize = true;
                  this->label14->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
                      static_cast<System::Byte>(0)));
                  this->label14->Location = System::Drawing::Point(339, 33);
                  this->label14->Name = L"label14";
                  this->label14->Size = System::Drawing::Size(67, 13);
                  this->label14->TabIndex = 45;
                  this->label14->Text = L"Source View";
                  // 
                  // m_sourceListView
                  // 
                  this->m_sourceListView->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
                      | System::Windows::Forms::AnchorStyles::Left) 
                      | System::Windows::Forms::AnchorStyles::Right));
                  this->m_sourceListView->AutoArrange = false;
                  this->m_sourceListView->Columns->AddRange(gcnew cli::array< System::Windows::Forms::ColumnHeader^  >(1) {this->columnHeader1});
                  this->m_sourceListView->Font = (gcnew System::Drawing::Font(L"Courier New", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
                      static_cast<System::Byte>(0)));
                  this->m_sourceListView->HeaderStyle = System::Windows::Forms::ColumnHeaderStyle::None;
                  this->m_sourceListView->LabelWrap = false;
                  this->m_sourceListView->Location = System::Drawing::Point(341, 49);
                  this->m_sourceListView->MultiSelect = false;
                  this->m_sourceListView->Name = L"m_sourceListView";
                  this->m_sourceListView->ShowGroups = false;
                  this->m_sourceListView->Size = System::Drawing::Size(345, 373);
                  this->m_sourceListView->SmallImageList = this->m_debuggerImageList;
                  this->m_sourceListView->TabIndex = 46;
                  this->m_sourceListView->UseCompatibleStateImageBehavior = false;
                  this->m_sourceListView->View = System::Windows::Forms::View::Details;
                  this->m_sourceListView->ItemSelectionChanged += gcnew System::Windows::Forms::ListViewItemSelectionChangedEventHandler(this, &MainForm::m_sourceListView_ItemSelectionChanged);
                  this->m_sourceListView->MouseClick += gcnew System::Windows::Forms::MouseEventHandler(this, &MainForm::m_sourceListView_MouseClick);
                  // 
                  // columnHeader1
                  // 
                  this->columnHeader1->Width = 320;
                  // 
                  // m_debuggerImageList
                  // 
                  this->m_debuggerImageList->ImageStream = (cli::safe_cast<System::Windows::Forms::ImageListStreamer^  >(resources->GetObject(L"m_debuggerImageList.ImageStream")));
                  this->m_debuggerImageList->TransparentColor = System::Drawing::Color::Transparent;
                  this->m_debuggerImageList->Images->SetKeyName(0, L"arrow");
                  this->m_debuggerImageList->Images->SetKeyName(1, L"breakpoint");
                  this->m_debuggerImageList->Images->SetKeyName(2, L"breakpoint with arrow");
                  this->m_debuggerImageList->Images->SetKeyName(3, L"stackframe");
                  this->m_debuggerImageList->Images->SetKeyName(4, L"breakpoint with stackframe");
                  // 
                  // m_microSourceListView
                  // 
                  this->m_microSourceListView->Anchor = static_cast<System::Windows::Forms::AnchorStyles>(((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
                      | System::Windows::Forms::AnchorStyles::Left));
                  this->m_microSourceListView->AutoArrange = false;
                  this->m_microSourceListView->Columns->AddRange(gcnew cli::array< System::Windows::Forms::ColumnHeader^  >(1) {this->columnHeader2});
                  this->m_microSourceListView->Font = (gcnew System::Drawing::Font(L"Courier New", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
                      static_cast<System::Byte>(0)));
                  this->m_microSourceListView->HeaderStyle = System::Windows::Forms::ColumnHeaderStyle::None;
                  this->m_microSourceListView->LabelWrap = false;
                  this->m_microSourceListView->Location = System::Drawing::Point(9, 338);
                  this->m_microSourceListView->Margin = System::Windows::Forms::Padding(0);
                  this->m_microSourceListView->MultiSelect = false;
                  this->m_microSourceListView->Name = L"m_microSourceListView";
                  this->m_microSourceListView->ShowGroups = false;
                  this->m_microSourceListView->Size = System::Drawing::Size(307, 84);
                  this->m_microSourceListView->SmallImageList = this->m_debuggerImageList;
                  this->m_microSourceListView->TabIndex = 47;
                  this->m_microSourceListView->UseCompatibleStateImageBehavior = false;
                  this->m_microSourceListView->View = System::Windows::Forms::View::Details;
                  this->m_microSourceListView->ItemSelectionChanged += gcnew System::Windows::Forms::ListViewItemSelectionChangedEventHandler(this, &MainForm::m_microSourceListView_ItemSelectionChanged);
                  this->m_microSourceListView->SizeChanged += gcnew System::EventHandler(this, &MainForm::m_microSourceListView_SizeChanged);
                  this->m_microSourceListView->MouseClick += gcnew System::Windows::Forms::MouseEventHandler(this, &MainForm::m_microSourceListView_MouseClick);
                  // 
                  // columnHeader2
                  // 
                  this->columnHeader2->Width = 450;
                  // 
                  // m_clearBreakpointsButton
                  // 
                  this->m_clearBreakpointsButton->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Right));
                  this->m_clearBreakpointsButton->Location = System::Drawing::Point(559, 428);
                  this->m_clearBreakpointsButton->Name = L"m_clearBreakpointsButton";
                  this->m_clearBreakpointsButton->Size = System::Drawing::Size(127, 23);
                  this->m_clearBreakpointsButton->TabIndex = 48;
                  this->m_clearBreakpointsButton->Text = L"Delete All Breakpoints";
                  this->m_clearBreakpointsButton->UseVisualStyleBackColor = true;
                  this->m_clearBreakpointsButton->Click += gcnew System::EventHandler(this, &MainForm::m_clearBreakpointsButton_Click);
                  // 
                  // menuStrip1
                  // 
                  this->menuStrip1->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(1) {this->fileToolStripMenuItem});
                  this->menuStrip1->Location = System::Drawing::Point(0, 0);
                  this->menuStrip1->Name = L"menuStrip1";
                  this->menuStrip1->Size = System::Drawing::Size(705, 24);
                  this->menuStrip1->TabIndex = 49;
                  this->menuStrip1->Text = L"menuStrip1";
                  // 
                  // fileToolStripMenuItem
                  // 
                  this->fileToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(8) {this->openProgramROMToolStripMenuItem, 
                      this->toolStripMenuItem2, this->toolStripMenuItem3, this->toolStripMenuItem4, this->toolStripMenuItem5, this->toolStripMenuItem6, 
                      this->toolStripMenuItem1, this->exitToolStripMenuItem});
                  this->fileToolStripMenuItem->Name = L"fileToolStripMenuItem";
                  this->fileToolStripMenuItem->Size = System::Drawing::Size(37, 20);
                  this->fileToolStripMenuItem->Text = L"File";
                  // 
                  // openProgramROMToolStripMenuItem
                  // 
                  this->openProgramROMToolStripMenuItem->Name = L"openProgramROMToolStripMenuItem";
                  this->openProgramROMToolStripMenuItem->Size = System::Drawing::Size(220, 22);
                  this->openProgramROMToolStripMenuItem->Text = L"Open Program File...";
                  this->openProgramROMToolStripMenuItem->Click += gcnew System::EventHandler(this, &MainForm::openProgramROMToolStripMenuItem_Click);
                  // 
                  // toolStripMenuItem2
                  // 
                  this->toolStripMenuItem2->Name = L"toolStripMenuItem2";
                  this->toolStripMenuItem2->Size = System::Drawing::Size(220, 22);
                  this->toolStripMenuItem2->Text = L"Open Symbol File...";
                  this->toolStripMenuItem2->Click += gcnew System::EventHandler(this, &MainForm::toolStripMenuItem2_Click);
                  // 
                  // toolStripMenuItem3
                  // 
                  this->toolStripMenuItem3->Name = L"toolStripMenuItem3";
                  this->toolStripMenuItem3->Size = System::Drawing::Size(220, 22);
                  // 
                  // toolStripMenuItem4
                  // 
                  this->toolStripMenuItem4->Name = L"toolStripMenuItem4";
                  this->toolStripMenuItem4->Size = System::Drawing::Size(220, 22);
                  this->toolStripMenuItem4->Text = L"Set Program Start Address...";
                  this->toolStripMenuItem4->Click += gcnew System::EventHandler(this, &MainForm::toolStripMenuItem4_Click);
                  // 
                  // toolStripMenuItem5
                  // 
                  this->toolStripMenuItem5->Name = L"toolStripMenuItem5";
                  this->toolStripMenuItem5->Size = System::Drawing::Size(220, 22);
                  this->toolStripMenuItem5->Text = L"Set Memory Breakpoint...";
                  this->toolStripMenuItem5->Click += gcnew System::EventHandler(this, &MainForm::toolStripMenuItem5_Click);
                  // 
                  // toolStripMenuItem6
                  // 
                  this->toolStripMenuItem6->Name = L"toolStripMenuItem6";
                  this->toolStripMenuItem6->Size = System::Drawing::Size(220, 22);
                  this->toolStripMenuItem6->Text = L"Clear Memory Breakpoint";
                  this->toolStripMenuItem6->Click += gcnew System::EventHandler(this, &MainForm::toolStripMenuItem6_Click);
                  // 
                  // toolStripMenuItem1
                  // 
                  this->toolStripMenuItem1->Name = L"toolStripMenuItem1";
                  this->toolStripMenuItem1->Size = System::Drawing::Size(217, 6);
                  // 
                  // exitToolStripMenuItem
                  // 
                  this->exitToolStripMenuItem->Name = L"exitToolStripMenuItem";
                  this->exitToolStripMenuItem->Size = System::Drawing::Size(220, 22);
                  this->exitToolStripMenuItem->Text = L"Exit";
                  this->exitToolStripMenuItem->Click += gcnew System::EventHandler(this, &MainForm::exitToolStripMenuItem_Click);
                  // 
                  // m_ShowDisassemblyCheckbox
                  // 
                  this->m_ShowDisassemblyCheckbox->AutoSize = true;
                  this->m_ShowDisassemblyCheckbox->Location = System::Drawing::Point(443, 32);
                  this->m_ShowDisassemblyCheckbox->Name = L"m_ShowDisassemblyCheckbox";
                  this->m_ShowDisassemblyCheckbox->Size = System::Drawing::Size(114, 17);
                  this->m_ShowDisassemblyCheckbox->TabIndex = 50;
                  this->m_ShowDisassemblyCheckbox->Text = L"Show Disassembly";
                  this->m_ShowDisassemblyCheckbox->UseVisualStyleBackColor = true;
                  this->m_ShowDisassemblyCheckbox->CheckedChanged += gcnew System::EventHandler(this, &MainForm::m_ShowDisassemblyCheckbox_CheckedChanged);
                  // 
                  // m_buttonLeft
                  // 
                  this->m_buttonLeft->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Left));
                  this->m_buttonLeft->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"m_buttonLeft.Image")));
                  this->m_buttonLeft->Location = System::Drawing::Point(342, 428);
                  this->m_buttonLeft->Name = L"m_buttonLeft";
                  this->m_buttonLeft->Size = System::Drawing::Size(23, 23);
                  this->m_buttonLeft->TabIndex = 51;
                  this->m_buttonLeft->UseVisualStyleBackColor = true;
                  this->m_buttonLeft->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &MainForm::m_buttonLeft_MouseDown);
                  this->m_buttonLeft->MouseUp += gcnew System::Windows::Forms::MouseEventHandler(this, &MainForm::m_buttonLeft_MouseUp);
                  // 
                  // m_buttonRight
                  // 
                  this->m_buttonRight->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Left));
                  this->m_buttonRight->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"m_buttonRight.Image")));
                  this->m_buttonRight->Location = System::Drawing::Point(371, 428);
                  this->m_buttonRight->Name = L"m_buttonRight";
                  this->m_buttonRight->Size = System::Drawing::Size(23, 23);
                  this->m_buttonRight->TabIndex = 52;
                  this->m_buttonRight->UseVisualStyleBackColor = true;
                  this->m_buttonRight->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &MainForm::m_buttonRight_MouseDown);
                  this->m_buttonRight->MouseUp += gcnew System::Windows::Forms::MouseEventHandler(this, &MainForm::m_buttonRight_MouseUp);
                  // 
                  // m_buttonUp
                  // 
                  this->m_buttonUp->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Left));
                  this->m_buttonUp->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"m_buttonUp.Image")));
                  this->m_buttonUp->Location = System::Drawing::Point(458, 428);
                  this->m_buttonUp->Name = L"m_buttonUp";
                  this->m_buttonUp->Size = System::Drawing::Size(23, 23);
                  this->m_buttonUp->TabIndex = 53;
                  this->m_buttonUp->UseVisualStyleBackColor = true;
                  this->m_buttonUp->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &MainForm::m_buttonUp_MouseDown);
                  this->m_buttonUp->MouseUp += gcnew System::Windows::Forms::MouseEventHandler(this, &MainForm::m_buttonUp_MouseUp);
                  // 
                  // m_buttonDown
                  // 
                  this->m_buttonDown->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Left));
                  this->m_buttonDown->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"m_buttonDown.Image")));
                  this->m_buttonDown->Location = System::Drawing::Point(429, 428);
                  this->m_buttonDown->Name = L"m_buttonDown";
                  this->m_buttonDown->Size = System::Drawing::Size(23, 23);
                  this->m_buttonDown->TabIndex = 54;
                  this->m_buttonDown->UseVisualStyleBackColor = true;
                  this->m_buttonDown->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &MainForm::m_buttonDown_MouseDown);
                  this->m_buttonDown->MouseUp += gcnew System::Windows::Forms::MouseEventHandler(this, &MainForm::m_buttonDown_MouseUp);
                  // 
                  // m_statusLabel
                  // 
                  this->m_statusLabel->AutoSize = true;
                  this->m_statusLabel->Location = System::Drawing::Point(7, 474);
                  this->m_statusLabel->Name = L"m_statusLabel";
                  this->m_statusLabel->Size = System::Drawing::Size(130, 13);
                  this->m_statusLabel->TabIndex = 55;
                  this->m_statusLabel->Text = L"Running - 123 clocks/sec";
                  // 
                  // m_timeLabel
                  // 
                  this->m_timeLabel->AutoSize = true;
                  this->m_timeLabel->Location = System::Drawing::Point(525, 474);
                  this->m_timeLabel->Name = L"m_timeLabel";
                  this->m_timeLabel->Size = System::Drawing::Size(69, 13);
                  this->m_timeLabel->TabIndex = 56;
                  this->m_timeLabel->Text = L"3,000,000 us";
                  // 
                  // m_resetTimeButton
                  // 
                  this->m_resetTimeButton->Location = System::Drawing::Point(636, 469);
                  this->m_resetTimeButton->Name = L"m_resetTimeButton";
                  this->m_resetTimeButton->Size = System::Drawing::Size(50, 23);
                  this->m_resetTimeButton->TabIndex = 57;
                  this->m_resetTimeButton->Text = L"Clear";
                  this->m_resetTimeButton->UseVisualStyleBackColor = true;
                  this->m_resetTimeButton->Click += gcnew System::EventHandler(this, &MainForm::m_resetTimeButton_Click);
                  // 
                  // MainForm
                  // 
                  this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
                  this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
                  this->ClientSize = System::Drawing::Size(705, 496);
                  this->Controls->Add(this->m_resetTimeButton);
                  this->Controls->Add(this->m_timeLabel);
                  this->Controls->Add(this->m_statusLabel);
                  this->Controls->Add(this->m_buttonDown);
                  this->Controls->Add(this->m_buttonUp);
                  this->Controls->Add(this->m_buttonRight);
                  this->Controls->Add(this->m_buttonLeft);
                  this->Controls->Add(this->m_ShowDisassemblyCheckbox);
                  this->Controls->Add(this->m_lcdTextBox);
                  this->Controls->Add(this->m_clearBreakpointsButton);
                  this->Controls->Add(this->label10);
                  this->Controls->Add(this->m_microSourceListView);
                  this->Controls->Add(this->m_sourceListView);
                  this->Controls->Add(this->label14);
                  this->Controls->Add(this->m_microDisassemblyViewTitle);
                  this->Controls->Add(this->m_microStepButton);
                  this->Controls->Add(this->m_stepButton);
                  this->Controls->Add(this->m_resetButton);
                  this->Controls->Add(this->m_pauseButton);
                  this->Controls->Add(this->m_continueButtton);
                  this->Controls->Add(this->label11);
                  this->Controls->Add(this->m_memoryViewTextBox);
                  this->Controls->Add(this->panel1);
                  this->Controls->Add(this->menuStrip1);
                  this->Icon = (cli::safe_cast<System::Drawing::Icon^  >(resources->GetObject(L"$this.Icon")));
                  this->MainMenuStrip = this->menuStrip1;
                  this->Name = L"MainForm";
                  this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
                  this->Text = L"Nibbler";
                  this->Load += gcnew System::EventHandler(this, &MainForm::MainForm_Load);
                  this->panel1->ResumeLayout(false);
                  this->panel1->PerformLayout();
                  this->menuStrip1->ResumeLayout(false);
                  this->menuStrip1->PerformLayout();
                  this->ResumeLayout(false);
                  this->PerformLayout();

              }
#pragma endregion
public:
	unsigned long m_memoryBreakpointAddress;
private: 
	MachineState^ m_machineState;
	Disassembly^ m_disassembler;
	MicroDisassembly^ m_microDisassembler;
	unsigned char m_executingOpcode;
	unsigned long m_executingPC;
	unsigned long m_memoryViewAddress;
	unsigned long m_currentInstructionAddress;
	unsigned long m_sourceDisassemblyStartAddress;
	unsigned long m_stepOverDestinationAddress;
	unsigned long m_bootAddress;
	unsigned long m_currentStackFrameAddress;
	String^ m_bootImage;
	bool m_ignoreSource;
	bool m_running;
	bool m_steppingOut;
	int m_stepOutCount;
	int m_stepsSinceLastInterrupt;
	int m_refreshCycles;
	DateTime m_lastUpdateTime;
       TimeSpan m_lastFrameDuration;
       unsigned long m_clocksSinceReset;
	Dictionary<unsigned long, bool> m_sourceBreakpoints;
	Dictionary<unsigned long, List<unsigned long>^> m_microSourceBreakpoints;
	Dictionary<unsigned long, FileAndLine> m_addressToSource;
	Dictionary<String^, unsigned long> m_sourceStartAddress;
	List<unsigned long> m_stackFrames;
       static const float s_clockSpeedMHz = 2.4576f;

	void MainForm_Load(System::Object^  sender, System::EventArgs^  e) 
	{
		Application::Idle += gcnew System::EventHandler(this, &MainForm::OnIdle);
		InitializeSimulation();
	}

	void OnIdle(System::Object^  sender, System::EventArgs^  e);

	void m_memoryAddressTextBox_Validated(System::Object^  sender, System::EventArgs^  e) 
	{
		FillMemoryTextBox(m_memoryViewTextBox, m_memoryViewAddress, 0, false);
	}

	void m_sourceListView_MouseClick(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) 
	{
		if (!m_running)
		{
			ListView^ sourceListView = safe_cast<ListView^>(sender);
			ListViewItem^ clickedItem = sourceListView->GetItemAt(e->X, e->Y);
			if (clickedItem)
			{
				unsigned long breakpointAddress = safe_cast<unsigned long>(clickedItem->Tag);

				if (m_sourceBreakpoints.ContainsKey(breakpointAddress))
				{
					m_sourceBreakpoints.Remove(breakpointAddress);
				}
				else
				{
					m_sourceBreakpoints[breakpointAddress] = true;
				}
			}

			RefreshDisassemblyView(false);
		}
	}

	void m_microSourceListView_MouseClick(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) 
	{
		if (!m_running)
		{
			ListView^ microSourceListView = safe_cast<ListView^>(sender);
			ListViewItem^ clickedItem = microSourceListView->GetItemAt(e->X, e->Y);
			if (clickedItem)
			{
				KeyValuePair<unsigned long, unsigned long>^ breakpointData = safe_cast<KeyValuePair<unsigned long, unsigned long>^>(clickedItem->Tag);

				if (m_microSourceBreakpoints.ContainsKey(breakpointData->Key))
				{
					bool breakpointFound = false;
					
					List<unsigned long>^ conditionCodes = m_microSourceBreakpoints[breakpointData->Key];
					for each (unsigned long conditionCode in conditionCodes)
					{
						if (conditionCode == breakpointData->Value)
						{
							conditionCodes->Remove(conditionCode);
							if (conditionCodes->Count == 0)
							{
								m_microSourceBreakpoints.Remove(breakpointData->Key);
							}
							breakpointFound = true;
							break;
						}
					}

					if (!breakpointFound)
					{
						conditionCodes->Add(breakpointData->Value);
					}
				}
				else
				{
					List<unsigned long>^ conditionCodes = gcnew List<unsigned long>();
					conditionCodes->Add(breakpointData->Value);
					m_microSourceBreakpoints[breakpointData->Key] = conditionCodes;
				}
			}

			RefreshMicroDisassemblyView();
		}
	}

	void m_clearBreakpointsButton_Click(System::Object^  sender, System::EventArgs^  e) 
	{
		m_sourceBreakpoints.Clear();
		m_microSourceBreakpoints.Clear();

		RefreshDisassemblyView(false);
		RefreshMicroDisassemblyView();
	}
	
	void m_sourceListView_ItemSelectionChanged(System::Object^  sender, System::Windows::Forms::ListViewItemSelectionChangedEventArgs^  e) 
	{
		e->Item->Selected = false;
	}

	void m_microSourceListView_ItemSelectionChanged(System::Object^  sender, System::Windows::Forms::ListViewItemSelectionChangedEventArgs^  e) 
	{
		e->Item->Selected = false;	
	}

	void m_microSourceListView_SizeChanged(System::Object^  sender, System::EventArgs^  e) 
	{
	//	ListView^ listView = safe_cast<ListView^>(sender);
	//	listView->Columns[0]->Width = listView->Width - 4;
	}

	void m_microStepButton_Click(System::Object^  sender, System::EventArgs^  e);

	void m_stepButton_Click(System::Object^  sender, System::EventArgs^  e);

	void m_resetButton_Click(System::Object^  sender, System::EventArgs^  e);

	void m_continueButtton_Click(System::Object^  sender, System::EventArgs^  e);

	void m_pauseButton_Click(System::Object^  sender, System::EventArgs^  e);

	void toolStripMenuItem2_Click(System::Object^  sender, System::EventArgs^  e);

	void openProgramROMToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e);

	void InitializeSimulation();
	bool CurrentMicroaddressIsAtBreakpoint();
	void RefreshData();
	void RefreshDisassemblyView(bool scrollToCurrentInstruction);
	void RefreshMicroDisassemblyView();
	void FillMemoryTextBox(TextBox^ textBox, unsigned long startAddress, unsigned long highlightAddress, bool highlight);
	void FillConsoleTextBox(TextBox^ textBox);
	void LoadSourceLabels(String^ filename);
	bool RetireInstruction();
	void m_ShowDisassemblyCheckbox_CheckedChanged(System::Object^  sender, System::EventArgs^  e);
	void exitToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			 Application::Exit();
		 }

	void toolStripMenuItem4_Click(System::Object^  sender, System::EventArgs^  e);
	void toolStripMenuItem5_Click(System::Object^  sender, System::EventArgs^  e);
	void toolStripMenuItem6_Click(System::Object^  sender, System::EventArgs^  e);
       void m_buttonLeft_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e);
       void m_buttonLeft_MouseUp(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e);
       void m_buttonRight_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e);
       void m_buttonRight_MouseUp(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e);
       void m_buttonDown_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e);
       void m_buttonDown_MouseUp(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e);
       void m_buttonUp_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e);
       void m_buttonUp_MouseUp(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e);
private: System::Void m_resetTimeButton_Click(System::Object^  sender, System::EventArgs^  e) {
             m_clocksSinceReset = 0;
             m_timeLabel->Text = String::Format("Time: {0:N0} us", m_clocksSinceReset/2);
         }
};



	
}

