#pragma once

using namespace System::Windows::Forms;
using namespace System::Collections::Generic;

namespace Simulator {

	ref class MachineState;

	using namespace System;

	public value class MicroInstructionData
	{
	public:
		property unsigned char Carry;
		property unsigned char Zero;
	};

	public ref class MicroDisassembly 
	{
	public:
		MicroDisassembly(MachineState^ machineState);

		void FillDisassemblyListView(ListView^ listView, Dictionary<unsigned long, List<unsigned long>^>^ microSourceBreakpoints);

	protected:
		~MicroDisassembly() {}
		String^ ConditionString(unsigned char bits, String^ name, bool isActiveLow);
		String^ RightALUString(unsigned long microOp);
		String^ MicroOpDescription(unsigned long microOp, unsigned char phase);
		Dictionary<unsigned long, MicroInstructionData> m_microInstructionLookup;
		MachineState^ m_machineState;
	};
}

